//------------------------------------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA,
//
//  or visit http://www.gnu.org/copyleft/gpl.html .
//
//------------------------------------------------------------------------------------
#define AVISYNTH_2_5

#ifndef AVISYNTH_2_5
	#define	AVISYNTH_H	"avisynth.h"
	#define	AVISYNTHPLUGININIT	AvisynthPluginInit
	typedef int			__INT64;
#else
	#define AVISYNTH_H	"avisynth2.h"
	#define	AVISYNTHPLUGININIT	AvisynthPluginInit2
	typedef __int64		__INT64;
#endif

#ifdef _MSC_VER
	#include <crtdbg.h>
	#if _MSC_VER == 1100	//MSC5.0 ?
		#define noreturn
	#endif
#else
	#define _ASSERTE(x) assert(x)
	#include <assert.h>
#endif


#include <windows.h>
#include <stdio.h>
#include <malloc.h>
#include AVISYNTH_H

class DNR : public GenericVideoFilter
{
	int threshY_hi,threshY_lo,threshU_hi,threshU_lo,threshV_hi,threshV_lo;
	int dnr_type;
	int pitch, w, h;
	int OldFrameNo;

	// Used by field matching.
	PVideoFrame fc, fb;
	unsigned char *old_data;
	unsigned char *fcp, *fbp;
	unsigned char *divTable;
	__int64		  thresh1, thresh2;

public:
	DNR::DNR(PClip _child,	int _threshY_hi, int _threshY_lo,
							int _threshU_hi, int _threshU_lo,
							int _threshV_hi, int _threshV_lo,
							int _dnr_type,
						IScriptEnvironment* env);
	DNR::~DNR();
    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
private:
	void CopyFrame(const unsigned char *dst, const unsigned char *src,
					 int w, int h, int pitch, int rowsize);
};

class DNR_YV12 : public GenericVideoFilter
{
	int threshY_hi,threshY_lo,threshU_hi,threshU_lo,threshV_hi,threshV_lo;
	int dnr_type;
	int pitch, w, h;
	int OldFrameNo;

	// Used by field matching.
	PVideoFrame fc, fb;
	PVideoFrame dst;
	unsigned char *fcp, *fbp;

	unsigned char *old_data[3];
	unsigned char *divTable;
	__int64		  thresh1, thresh2;
	__int64		  threshU1, threshU2, threshV1, threshV2;	//for YV12

public:
	DNR_YV12::DNR_YV12(PClip _child,	int _threshY_hi, int _threshY_lo,
							int _threshU_hi, int _threshU_lo,
							int _threshV_hi, int _threshV_lo,
							int _dnr_type,
						IScriptEnvironment* env);
	DNR_YV12::~DNR_YV12();
    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
private:
	void CopyFrame(PVideoFrame &src, IScriptEnvironment* env);
};

void dodnr1MMX(unsigned char *dst, unsigned char *src,	int w, int h,
								 int dstmodulo,  __int64 thresh1, __int64 thresh2);
void dodnr2MMX(unsigned char *dst, unsigned char *src,	int w, int h,
								 int dstmodulo,  __int64 thresh1, __int64 thresh2);

typedef void (*fpDODNRMMX)(unsigned char *, unsigned char *, int, int, int, __int64, __int64);
